Option Strict Off
Option Explicit On 
Imports VB = Microsoft.VisualBasic
Imports System.Drawing.Printing         'Added by Greg, supposed influence in printing things
Imports System.IO
Friend Class frmMain
    Inherits System.Windows.Forms.Form
#Region "Windows Form Designer generated code "
    Public Sub New()
        MyBase.New()
        If m_vb6FormDefInstance Is Nothing Then
            m_vb6FormDefInstance = Me
        End If
        'This call is required by the Windows Form Designer.
        InitializeComponent()
    End Sub
    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
        If Disposing Then
            If Not components Is Nothing Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(Disposing)
    End Sub
    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Public ToolTip1 As System.Windows.Forms.ToolTip
    Public WithEvents cdlDialog As AxMSComDlg.AxCommonDialog
    Public WithEvents StatusBar1 As Axmscomctl.AxStatusBar          'Greg changed from AxMSComctlLib.AxStatusBar
    Public WithEvents imlIcons As Axmscomctl.AxImageList            'Greg changed from AxMSComctlLib.AxImageList
    Public WithEvents tbrToolBar As Axmscomctl.AxToolbar            'Greg changed from AxMSComctlLib.AxToolbar
    Public WithEvents mnuFileNew As System.Windows.Forms.MenuItem
    Public WithEvents mnuFileOpen As System.Windows.Forms.MenuItem
    Public WithEvents mnuFileSep1 As System.Windows.Forms.MenuItem
    Public WithEvents mnuFileSave As System.Windows.Forms.MenuItem
    Public WithEvents mnuFileSaveAs As System.Windows.Forms.MenuItem
    Public WithEvents mnuFileSep2 As System.Windows.Forms.MenuItem
    Public WithEvents mnuFilePrint As System.Windows.Forms.MenuItem
    Public WithEvents mnuFileSep3 As System.Windows.Forms.MenuItem
    Public WithEvents mnuFileExit As System.Windows.Forms.MenuItem
    Public WithEvents mnuFile As System.Windows.Forms.MenuItem
    Public WithEvents mnuHelpAbout As System.Windows.Forms.MenuItem
    Public WithEvents mnuHelp As System.Windows.Forms.MenuItem
    Public MainMenu1 As System.Windows.Forms.MainMenu
    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    Friend WithEvents dlgOpenFile As System.Windows.Forms.OpenFileDialog
    Friend WithEvents dlgSaveFile As System.Windows.Forms.SaveFileDialog
    Public WithEvents lstStaticList As System.Windows.Forms.ListBox
    Public WithEvents lblInfo As System.Windows.Forms.Label
    Public WithEvents fraVariables As System.Windows.Forms.GroupBox
    Public WithEvents lvwVariables As Axmscomctl.AxListView
    Public WithEvents btnAddVariable As System.Windows.Forms.Button
    Public WithEvents btnEditVariable As System.Windows.Forms.Button
    Public WithEvents btnRemoveVariable As System.Windows.Forms.Button
    Public WithEvents txtIf As System.Windows.Forms.TextBox
    Public WithEvents lblIf As System.Windows.Forms.Label
    Public WithEvents fraRules As System.Windows.Forms.GroupBox
    Public WithEvents btnRemove As System.Windows.Forms.Button
    Public WithEvents btnAdd As System.Windows.Forms.Button
    Public WithEvents lvwRule As Axmscomctl.AxListView
    Friend WithEvents pnlConditions As System.Windows.Forms.Panel
    Friend WithEvents pnlRules As System.Windows.Forms.Panel
    Friend WithEvents pnlVariableValues As System.Windows.Forms.Panel
    Friend WithEvents pnlVariables As System.Windows.Forms.Panel
    Friend WithEvents pnlValues As System.Windows.Forms.Panel
    Friend WithEvents lblValues As System.Windows.Forms.Label
    Public WithEvents lblThen As System.Windows.Forms.Label
    Public WithEvents txtThen As System.Windows.Forms.TextBox
    Friend WithEvents btnEditRule As System.Windows.Forms.Button
    Friend WithEvents mnuFilePublish As System.Windows.Forms.MenuItem
    Friend WithEvents dlgSavePublish As System.Windows.Forms.SaveFileDialog
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(frmMain))
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.StatusBar1 = New Axmscomctl.AxStatusBar
        Me.imlIcons = New Axmscomctl.AxImageList
        Me.tbrToolBar = New Axmscomctl.AxToolbar
        Me.MainMenu1 = New System.Windows.Forms.MainMenu
        Me.mnuFile = New System.Windows.Forms.MenuItem
        Me.mnuFileNew = New System.Windows.Forms.MenuItem
        Me.mnuFileOpen = New System.Windows.Forms.MenuItem
        Me.mnuFileSep1 = New System.Windows.Forms.MenuItem
        Me.mnuFilePublish = New System.Windows.Forms.MenuItem
        Me.mnuFileSave = New System.Windows.Forms.MenuItem
        Me.mnuFileSaveAs = New System.Windows.Forms.MenuItem
        Me.mnuFileSep2 = New System.Windows.Forms.MenuItem
        Me.mnuFilePrint = New System.Windows.Forms.MenuItem
        Me.mnuFileSep3 = New System.Windows.Forms.MenuItem
        Me.mnuFileExit = New System.Windows.Forms.MenuItem
        Me.mnuHelp = New System.Windows.Forms.MenuItem
        Me.mnuHelpAbout = New System.Windows.Forms.MenuItem
        Me.dlgOpenFile = New System.Windows.Forms.OpenFileDialog
        Me.dlgSaveFile = New System.Windows.Forms.SaveFileDialog
        Me.lstStaticList = New System.Windows.Forms.ListBox
        Me.lblInfo = New System.Windows.Forms.Label
        Me.fraVariables = New System.Windows.Forms.GroupBox
        Me.pnlValues = New System.Windows.Forms.Panel
        Me.lblValues = New System.Windows.Forms.Label
        Me.btnEditVariable = New System.Windows.Forms.Button
        Me.lvwVariables = New Axmscomctl.AxListView
        Me.btnRemoveVariable = New System.Windows.Forms.Button
        Me.btnAddVariable = New System.Windows.Forms.Button
        Me.txtIf = New System.Windows.Forms.TextBox
        Me.lblIf = New System.Windows.Forms.Label
        Me.fraRules = New System.Windows.Forms.GroupBox
        Me.btnEditRule = New System.Windows.Forms.Button
        Me.btnRemove = New System.Windows.Forms.Button
        Me.btnAdd = New System.Windows.Forms.Button
        Me.lvwRule = New Axmscomctl.AxListView
        Me.pnlConditions = New System.Windows.Forms.Panel
        Me.lblThen = New System.Windows.Forms.Label
        Me.txtThen = New System.Windows.Forms.TextBox
        Me.pnlRules = New System.Windows.Forms.Panel
        Me.pnlVariableValues = New System.Windows.Forms.Panel
        Me.pnlVariables = New System.Windows.Forms.Panel
        Me.dlgSavePublish = New System.Windows.Forms.SaveFileDialog
        CType(Me.StatusBar1, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.imlIcons, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.tbrToolBar, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.fraVariables.SuspendLayout()
        Me.pnlValues.SuspendLayout()
        CType(Me.lvwVariables, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.fraRules.SuspendLayout()
        CType(Me.lvwRule, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.pnlConditions.SuspendLayout()
        Me.pnlRules.SuspendLayout()
        Me.pnlVariableValues.SuspendLayout()
        Me.pnlVariables.SuspendLayout()
        Me.SuspendLayout()
        '
        'StatusBar1
        '
        Me.StatusBar1.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.StatusBar1.ImeMode = System.Windows.Forms.ImeMode.NoControl
        Me.StatusBar1.Location = New System.Drawing.Point(0, 442)
        Me.StatusBar1.Name = "StatusBar1"
        Me.StatusBar1.OcxState = CType(resources.GetObject("StatusBar1.OcxState"), System.Windows.Forms.AxHost.State)
        Me.StatusBar1.Size = New System.Drawing.Size(742, 27)
        Me.StatusBar1.TabIndex = 1
        '
        'imlIcons
        '
        Me.imlIcons.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.imlIcons.ContainingControl = Me
        Me.imlIcons.Enabled = True
        Me.imlIcons.Location = New System.Drawing.Point(112, 344)
        Me.imlIcons.Name = "imlIcons"
        Me.imlIcons.OcxState = CType(resources.GetObject("imlIcons.OcxState"), System.Windows.Forms.AxHost.State)
        Me.imlIcons.Size = New System.Drawing.Size(38, 38)
        Me.imlIcons.TabIndex = 2
        '
        'tbrToolBar
        '
        Me.tbrToolBar.Dock = System.Windows.Forms.DockStyle.Top
        Me.tbrToolBar.Location = New System.Drawing.Point(0, 0)
        Me.tbrToolBar.Name = "tbrToolBar"
        Me.tbrToolBar.OcxState = CType(resources.GetObject("tbrToolBar.OcxState"), System.Windows.Forms.AxHost.State)
        Me.tbrToolBar.Size = New System.Drawing.Size(742, 38)
        Me.tbrToolBar.TabIndex = 0
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFile, Me.mnuHelp})
        '
        'mnuFile
        '
        Me.mnuFile.Index = 0
        Me.mnuFile.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFileNew, Me.mnuFileOpen, Me.mnuFileSep1, Me.mnuFilePublish, Me.mnuFileSave, Me.mnuFileSaveAs, Me.mnuFileSep2, Me.mnuFilePrint, Me.mnuFileSep3, Me.mnuFileExit})
        Me.mnuFile.MergeType = System.Windows.Forms.MenuMerge.Remove
        Me.mnuFile.Text = "&File"
        '
        'mnuFileNew
        '
        Me.mnuFileNew.Index = 0
        Me.mnuFileNew.MergeType = System.Windows.Forms.MenuMerge.Remove
        Me.mnuFileNew.Shortcut = System.Windows.Forms.Shortcut.CtrlN
        Me.mnuFileNew.Text = "&New"
        '
        'mnuFileOpen
        '
        Me.mnuFileOpen.Index = 1
        Me.mnuFileOpen.MergeType = System.Windows.Forms.MenuMerge.Remove
        Me.mnuFileOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO
        Me.mnuFileOpen.Text = "&Open"
        '
        'mnuFileSep1
        '
        Me.mnuFileSep1.Index = 2
        Me.mnuFileSep1.MergeType = System.Windows.Forms.MenuMerge.Remove
        Me.mnuFileSep1.Text = "-"
        '
        'mnuFilePublish
        '
        Me.mnuFilePublish.Index = 3
        Me.mnuFilePublish.Text = "&Publish"
        '
        'mnuFileSave
        '
        Me.mnuFileSave.Enabled = False
        Me.mnuFileSave.Index = 4
        Me.mnuFileSave.MergeType = System.Windows.Forms.MenuMerge.Remove
        Me.mnuFileSave.Shortcut = System.Windows.Forms.Shortcut.CtrlS
        Me.mnuFileSave.Text = "&Save"
        '
        'mnuFileSaveAs
        '
        Me.mnuFileSaveAs.Enabled = False
        Me.mnuFileSaveAs.Index = 5
        Me.mnuFileSaveAs.MergeType = System.Windows.Forms.MenuMerge.Remove
        Me.mnuFileSaveAs.Text = "Save &As..."
        '
        'mnuFileSep2
        '
        Me.mnuFileSep2.Index = 6
        Me.mnuFileSep2.MergeType = System.Windows.Forms.MenuMerge.Remove
        Me.mnuFileSep2.Text = "-"
        '
        'mnuFilePrint
        '
        Me.mnuFilePrint.Enabled = False
        Me.mnuFilePrint.Index = 7
        Me.mnuFilePrint.MergeType = System.Windows.Forms.MenuMerge.Remove
        Me.mnuFilePrint.Shortcut = System.Windows.Forms.Shortcut.CtrlP
        Me.mnuFilePrint.Text = "&Print..."
        '
        'mnuFileSep3
        '
        Me.mnuFileSep3.Index = 8
        Me.mnuFileSep3.MergeType = System.Windows.Forms.MenuMerge.Remove
        Me.mnuFileSep3.Text = "-"
        '
        'mnuFileExit
        '
        Me.mnuFileExit.Index = 9
        Me.mnuFileExit.MergeType = System.Windows.Forms.MenuMerge.Remove
        Me.mnuFileExit.Text = "E&xit"
        '
        'mnuHelp
        '
        Me.mnuHelp.Index = 1
        Me.mnuHelp.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuHelpAbout})
        Me.mnuHelp.MergeType = System.Windows.Forms.MenuMerge.Remove
        Me.mnuHelp.Text = "Help"
        '
        'mnuHelpAbout
        '
        Me.mnuHelpAbout.Index = 0
        Me.mnuHelpAbout.MergeType = System.Windows.Forms.MenuMerge.Remove
        Me.mnuHelpAbout.Text = "&About..."
        '
        'lstStaticList
        '
        Me.lstStaticList.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lstStaticList.BackColor = System.Drawing.SystemColors.Window
        Me.lstStaticList.Cursor = System.Windows.Forms.Cursors.Default
        Me.lstStaticList.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lstStaticList.ForeColor = System.Drawing.SystemColors.WindowText
        Me.lstStaticList.ItemHeight = 14
        Me.lstStaticList.Location = New System.Drawing.Point(5, 24)
        Me.lstStaticList.Name = "lstStaticList"
        Me.lstStaticList.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lstStaticList.Size = New System.Drawing.Size(276, 74)
        Me.lstStaticList.TabIndex = 7
        Me.lstStaticList.TabStop = False
        Me.lstStaticList.Visible = False
        '
        'lblInfo
        '
        Me.lblInfo.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lblInfo.BackColor = System.Drawing.SystemColors.Control
        Me.lblInfo.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblInfo.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblInfo.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblInfo.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblInfo.Location = New System.Drawing.Point(5, 24)
        Me.lblInfo.Name = "lblInfo"
        Me.lblInfo.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblInfo.Size = New System.Drawing.Size(276, 74)
        Me.lblInfo.TabIndex = 8
        Me.lblInfo.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'fraVariables
        '
        Me.fraVariables.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.fraVariables.BackColor = System.Drawing.SystemColors.Control
        Me.fraVariables.Controls.Add(Me.pnlValues)
        Me.fraVariables.Controls.Add(Me.btnEditVariable)
        Me.fraVariables.Controls.Add(Me.lvwVariables)
        Me.fraVariables.Controls.Add(Me.btnRemoveVariable)
        Me.fraVariables.Controls.Add(Me.btnAddVariable)
        Me.fraVariables.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.fraVariables.ForeColor = System.Drawing.SystemColors.ControlText
        Me.fraVariables.Location = New System.Drawing.Point(0, 0)
        Me.fraVariables.Name = "fraVariables"
        Me.fraVariables.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.fraVariables.Size = New System.Drawing.Size(294, 404)
        Me.fraVariables.TabIndex = 5
        Me.fraVariables.TabStop = False
        Me.fraVariables.Text = "Variables"
        '
        'pnlValues
        '
        Me.pnlValues.Controls.Add(Me.lblValues)
        Me.pnlValues.Controls.Add(Me.lstStaticList)
        Me.pnlValues.Controls.Add(Me.lblInfo)
        Me.pnlValues.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.pnlValues.Location = New System.Drawing.Point(3, 288)
        Me.pnlValues.Name = "pnlValues"
        Me.pnlValues.Size = New System.Drawing.Size(288, 113)
        Me.pnlValues.TabIndex = 9
        '
        'lblValues
        '
        Me.lblValues.Location = New System.Drawing.Point(5, 0)
        Me.lblValues.Name = "lblValues"
        Me.lblValues.Size = New System.Drawing.Size(72, 16)
        Me.lblValues.TabIndex = 9
        Me.lblValues.Text = "Values"
        '
        'btnEditVariable
        '
        Me.btnEditVariable.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnEditVariable.BackColor = System.Drawing.SystemColors.Control
        Me.btnEditVariable.Cursor = System.Windows.Forms.Cursors.Default
        Me.btnEditVariable.Enabled = False
        Me.btnEditVariable.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnEditVariable.ForeColor = System.Drawing.SystemColors.ControlText
        Me.btnEditVariable.Location = New System.Drawing.Point(214, 54)
        Me.btnEditVariable.Name = "btnEditVariable"
        Me.btnEditVariable.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.btnEditVariable.Size = New System.Drawing.Size(73, 25)
        Me.btnEditVariable.TabIndex = 2
        Me.btnEditVariable.Text = "&Edit"
        '
        'lvwVariables
        '
        Me.lvwVariables.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lvwVariables.ContainingControl = Me
        Me.lvwVariables.Location = New System.Drawing.Point(8, 22)
        Me.lvwVariables.Name = "lvwVariables"
        Me.lvwVariables.OcxState = CType(resources.GetObject("lvwVariables.OcxState"), System.Windows.Forms.AxHost.State)
        Me.lvwVariables.Size = New System.Drawing.Size(202, 258)
        Me.lvwVariables.TabIndex = 0
        '
        'btnRemoveVariable
        '
        Me.btnRemoveVariable.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnRemoveVariable.BackColor = System.Drawing.SystemColors.Control
        Me.btnRemoveVariable.Cursor = System.Windows.Forms.Cursors.Default
        Me.btnRemoveVariable.Enabled = False
        Me.btnRemoveVariable.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnRemoveVariable.ForeColor = System.Drawing.SystemColors.ControlText
        Me.btnRemoveVariable.Location = New System.Drawing.Point(214, 86)
        Me.btnRemoveVariable.Name = "btnRemoveVariable"
        Me.btnRemoveVariable.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.btnRemoveVariable.Size = New System.Drawing.Size(73, 25)
        Me.btnRemoveVariable.TabIndex = 3
        Me.btnRemoveVariable.Text = "&Remove"
        '
        'btnAddVariable
        '
        Me.btnAddVariable.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnAddVariable.BackColor = System.Drawing.SystemColors.Control
        Me.btnAddVariable.Cursor = System.Windows.Forms.Cursors.Default
        Me.btnAddVariable.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnAddVariable.ForeColor = System.Drawing.SystemColors.ControlText
        Me.btnAddVariable.Location = New System.Drawing.Point(214, 22)
        Me.btnAddVariable.Name = "btnAddVariable"
        Me.btnAddVariable.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.btnAddVariable.Size = New System.Drawing.Size(73, 25)
        Me.btnAddVariable.TabIndex = 1
        Me.btnAddVariable.Text = "&Add"
        '
        'txtIf
        '
        Me.txtIf.AcceptsReturn = True
        Me.txtIf.AutoSize = False
        Me.txtIf.BackColor = System.Drawing.SystemColors.Window
        Me.txtIf.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.txtIf.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtIf.ForeColor = System.Drawing.SystemColors.WindowText
        Me.txtIf.Location = New System.Drawing.Point(8, 20)
        Me.txtIf.MaxLength = 0
        Me.txtIf.Multiline = True
        Me.txtIf.Name = "txtIf"
        Me.txtIf.ReadOnly = True
        Me.txtIf.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.txtIf.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtIf.Size = New System.Drawing.Size(233, 144)
        Me.txtIf.TabIndex = 7
        Me.txtIf.TabStop = False
        Me.txtIf.Text = ""
        '
        'lblIf
        '
        Me.lblIf.BackColor = System.Drawing.SystemColors.Control
        Me.lblIf.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblIf.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblIf.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblIf.Location = New System.Drawing.Point(8, 0)
        Me.lblIf.Name = "lblIf"
        Me.lblIf.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblIf.Size = New System.Drawing.Size(33, 16)
        Me.lblIf.TabIndex = 5
        Me.lblIf.Text = "If..."
        '
        'fraRules
        '
        Me.fraRules.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.fraRules.BackColor = System.Drawing.SystemColors.Control
        Me.fraRules.Controls.Add(Me.btnEditRule)
        Me.fraRules.Controls.Add(Me.btnRemove)
        Me.fraRules.Controls.Add(Me.btnAdd)
        Me.fraRules.Controls.Add(Me.lvwRule)
        Me.fraRules.Controls.Add(Me.imlIcons)
        Me.fraRules.Controls.Add(Me.pnlConditions)
        Me.fraRules.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.fraRules.ForeColor = System.Drawing.SystemColors.ControlText
        Me.fraRules.Location = New System.Drawing.Point(8, 0)
        Me.fraRules.Name = "fraRules"
        Me.fraRules.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.fraRules.Size = New System.Drawing.Size(440, 404)
        Me.fraRules.TabIndex = 9
        Me.fraRules.TabStop = False
        Me.fraRules.Text = "Rules"
        '
        'btnEditRule
        '
        Me.btnEditRule.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnEditRule.Location = New System.Drawing.Point(108, 54)
        Me.btnEditRule.Name = "btnEditRule"
        Me.btnEditRule.Size = New System.Drawing.Size(73, 25)
        Me.btnEditRule.TabIndex = 12
        Me.btnEditRule.Text = "&Edit"
        '
        'btnRemove
        '
        Me.btnRemove.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnRemove.BackColor = System.Drawing.SystemColors.Control
        Me.btnRemove.Cursor = System.Windows.Forms.Cursors.Default
        Me.btnRemove.Enabled = False
        Me.btnRemove.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnRemove.ForeColor = System.Drawing.SystemColors.ControlText
        Me.btnRemove.Location = New System.Drawing.Point(108, 86)
        Me.btnRemove.Name = "btnRemove"
        Me.btnRemove.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.btnRemove.Size = New System.Drawing.Size(73, 25)
        Me.btnRemove.TabIndex = 5
        Me.btnRemove.Text = "&Remove"
        '
        'btnAdd
        '
        Me.btnAdd.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnAdd.BackColor = System.Drawing.SystemColors.Control
        Me.btnAdd.Cursor = System.Windows.Forms.Cursors.Default
        Me.btnAdd.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnAdd.ForeColor = System.Drawing.SystemColors.ControlText
        Me.btnAdd.Location = New System.Drawing.Point(108, 22)
        Me.btnAdd.Name = "btnAdd"
        Me.btnAdd.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.btnAdd.Size = New System.Drawing.Size(73, 25)
        Me.btnAdd.TabIndex = 4
        Me.btnAdd.Text = "&Add"
        '
        'lvwRule
        '
        Me.lvwRule.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.lvwRule.ContainingControl = Me
        Me.lvwRule.Location = New System.Drawing.Point(8, 22)
        Me.lvwRule.Name = "lvwRule"
        Me.lvwRule.OcxState = CType(resources.GetObject("lvwRule.OcxState"), System.Windows.Forms.AxHost.State)
        Me.lvwRule.Size = New System.Drawing.Size(92, 370)
        Me.lvwRule.TabIndex = 9
        '
        'pnlConditions
        '
        Me.pnlConditions.Controls.Add(Me.lblThen)
        Me.pnlConditions.Controls.Add(Me.txtThen)
        Me.pnlConditions.Controls.Add(Me.lblIf)
        Me.pnlConditions.Controls.Add(Me.txtIf)
        Me.pnlConditions.Dock = System.Windows.Forms.DockStyle.Right
        Me.pnlConditions.Location = New System.Drawing.Point(189, 22)
        Me.pnlConditions.Name = "pnlConditions"
        Me.pnlConditions.Size = New System.Drawing.Size(248, 379)
        Me.pnlConditions.TabIndex = 11
        '
        'lblThen
        '
        Me.lblThen.BackColor = System.Drawing.SystemColors.Control
        Me.lblThen.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblThen.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblThen.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblThen.Location = New System.Drawing.Point(8, 184)
        Me.lblThen.Name = "lblThen"
        Me.lblThen.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblThen.Size = New System.Drawing.Size(65, 16)
        Me.lblThen.TabIndex = 9
        Me.lblThen.Text = "Then..."
        '
        'txtThen
        '
        Me.txtThen.AcceptsReturn = True
        Me.txtThen.AutoSize = False
        Me.txtThen.BackColor = System.Drawing.SystemColors.Window
        Me.txtThen.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.txtThen.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtThen.ForeColor = System.Drawing.SystemColors.WindowText
        Me.txtThen.Location = New System.Drawing.Point(8, 204)
        Me.txtThen.MaxLength = 0
        Me.txtThen.Multiline = True
        Me.txtThen.Name = "txtThen"
        Me.txtThen.ReadOnly = True
        Me.txtThen.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.txtThen.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtThen.Size = New System.Drawing.Size(233, 165)
        Me.txtThen.TabIndex = 10
        Me.txtThen.TabStop = False
        Me.txtThen.Text = ""
        '
        'pnlRules
        '
        Me.pnlRules.Controls.Add(Me.fraRules)
        Me.pnlRules.Dock = System.Windows.Forms.DockStyle.Right
        Me.pnlRules.Location = New System.Drawing.Point(294, 38)
        Me.pnlRules.Name = "pnlRules"
        Me.pnlRules.Size = New System.Drawing.Size(448, 404)
        Me.pnlRules.TabIndex = 12
        '
        'pnlVariableValues
        '
        Me.pnlVariableValues.Controls.Add(Me.pnlVariables)
        Me.pnlVariableValues.Dock = System.Windows.Forms.DockStyle.Fill
        Me.pnlVariableValues.Location = New System.Drawing.Point(0, 38)
        Me.pnlVariableValues.Name = "pnlVariableValues"
        Me.pnlVariableValues.Size = New System.Drawing.Size(294, 404)
        Me.pnlVariableValues.TabIndex = 13
        '
        'pnlVariables
        '
        Me.pnlVariables.Controls.Add(Me.fraVariables)
        Me.pnlVariables.Dock = System.Windows.Forms.DockStyle.Fill
        Me.pnlVariables.Location = New System.Drawing.Point(0, 0)
        Me.pnlVariables.Name = "pnlVariables"
        Me.pnlVariables.Size = New System.Drawing.Size(294, 404)
        Me.pnlVariables.TabIndex = 8
        '
        'frmMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.SystemColors.Control
        Me.ClientSize = New System.Drawing.Size(742, 469)
        Me.Controls.Add(Me.pnlVariableValues)
        Me.Controls.Add(Me.pnlRules)
        Me.Controls.Add(Me.StatusBar1)
        Me.Controls.Add(Me.tbrToolBar)
        Me.Cursor = System.Windows.Forms.Cursors.Default
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Location = New System.Drawing.Point(15, 38)
        Me.Menu = Me.MainMenu1
        Me.MinimumSize = New System.Drawing.Size(750, 496)
        Me.Name = "frmMain"
        Me.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "::: FreeShell :::"
        Me.TransparencyKey = System.Drawing.Color.Purple
        CType(Me.StatusBar1, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.imlIcons, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.tbrToolBar, System.ComponentModel.ISupportInitialize).EndInit()
        Me.fraVariables.ResumeLayout(False)
        Me.pnlValues.ResumeLayout(False)
        CType(Me.lvwVariables, System.ComponentModel.ISupportInitialize).EndInit()
        Me.fraRules.ResumeLayout(False)
        CType(Me.lvwRule, System.ComponentModel.ISupportInitialize).EndInit()
        Me.pnlConditions.ResumeLayout(False)
        Me.pnlRules.ResumeLayout(False)
        Me.pnlVariableValues.ResumeLayout(False)
        Me.pnlVariables.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub
#End Region
#Region "Upgrade Support "
    Private Shared m_vb6FormDefInstance As frmMain
    Private Shared m_InitializingDefInstance As Boolean
    Public Shared Property DefInstance() As frmMain
        Get
            If m_vb6FormDefInstance Is Nothing OrElse m_vb6FormDefInstance.IsDisposed Then
                m_InitializingDefInstance = True
                m_vb6FormDefInstance = New frmMain
                m_InitializingDefInstance = False
            End If
            DefInstance = m_vb6FormDefInstance
        End Get
        Set(ByVal Value As frmMain)
            m_vb6FormDefInstance = Value
        End Set
    End Property
#End Region
    ' This form is the entry point to the Knowledge Base Editor. It provides the functions
    ' that allow the user to open and save knowledge bases, and loads and displays
    ' frmVariableEditor and frmRuleOrganizer. The menu and toolbar is also displayed here.
    '
    ' Form designed by Jim
    ' Coded by Jim, Brett, Mike, Brian
    '
    ' January 23
    '   Rewrote part of save function
    '   Brett
    ' January 24
    '   Rewrote part of open function
    '   Brett
    ' January 26
    '   Finished coding open and save functions
    '   Brett, Mike

    Dim saveCan As Boolean

    Dim publishTitle As String = ""
    Dim publishDescription As String = ""
    Dim publishBackColor As Color = Color.White
    Dim publishBackColorString As String = ""

    'UPGRADE_WARNING: Form event frmMain.Unload has a new behavior. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup2065"'
    Private Sub frmMain_Closed(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Closed
        ' On exit, unload all forms

        frmAbout.DefInstance.Close()
        frmAddVariable.DefInstance.Close()
        frmRuleCreator.DefInstance.Close()

    End Sub
    Public Sub mnuFileExit_Popup(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuFileExit.Popup
        mnuFileExit_Click(eventSender, eventArgs)
    End Sub
    Public Sub mnuFileExit_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuFileExit.Click
        ' Exit the program

        Me.Close()
        End

    End Sub
    Public Sub mnuFileNew_Popup(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuFileNew.Popup
        mnuFileNew_Click(eventSender, eventArgs)
    End Sub
    Public Sub mnuFileNew_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuFileNew.Click
        ' Resets environment for new knowledge base
        If saveCan Then
            Dim dlgResult As New DialogResult
            dlgResult = MessageBox.Show("Would you like to save the current expert System?", "Save", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question)
            If dlgResult = DialogResult.Yes Then
                mnuFileSave.PerformClick()
            ElseIf dlgResult = DialogResult.Cancel Then
                Exit Sub
            End If
        End If

        publishTitle = ""
        publishDescription = ""
        publishBackColor = Color.White
        publishBackColorString = ""

        ResetEnvironment()
        EnableEnvironment()

        strProjectFilename = "New Knowledge Base"
        Me.Text = "::: FreeShell ::: " & strProjectFilename & " :::"

        saveCan = False

    End Sub
    Public Sub mnuFileOpen_Popup(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuFileOpen.Popup
        mnuFileOpen_Click(eventSender, eventArgs)
    End Sub
    Public Sub mnuFileOpen_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuFileOpen.Click
        ' Open a knowledge base

        Dim dlgResult As DialogResult
        Dim strFileInputString As String
        Dim intLoopindex As Integer

        With dlgOpenFile
            .Title = "Open Knowledge Base"
            .InitialDirectory = Application.StartupPath
            .Filter = "FreeShell Knowledge Base (*.fsl)|*.fsl|All Files (*.*)|*.*"
            .ShowReadOnly = False
            dlgResult = dlgOpenFile.ShowDialog()
        End With

        If dlgResult <> DialogResult.Cancel Then
            strProjectFilename = dlgOpenFile.FileName
            Me.Text = "::: FreeShell ::: " & strProjectFilename & " :::"

            'contiue opening
            ResetEnvironment()
            EnableEnvironment()
            Dim datKBfile As New StreamReader(dlgOpenFile.FileName)
            strFileInputString = datKBfile.ReadLine()        'VARS:
            strFileInputString = datKBfile.ReadLine()        '
            strFileInputString = datKBfile.ReadLine()        'first_var, type, ...
            Dim strVariableDescription(3) As String                      '0- name, 1- type, 2- count or range, 3- question type and question
            Dim strQuestionParts(2) As String                            '0- question type, 1- question text, 2- ~trash~
            Dim strNumericParts(3) As String                             '0- "FROM", 1- num1, 2- "TO", 3- num2
            Dim intVariableMemberCount As Integer                        'number of list items
            'start looking for variables
            While strFileInputString <> "RULES:"
                If strFileInputString <> "" Then
                    'start parsing a variable
                    strVariableDescription = strFileInputString.Split(","c)
                    With frmAddVariable.DefInstance
                        .txtName.Text = strVariableDescription(0)
                        Select Case strVariableDescription(1).ToString()
                            Case " STATIC_LIST"
                                .lstStaticList.Items.Clear()
                                .cboType.Text = "Static List"
                                intVariableMemberCount = CInt(strVariableDescription(2))
                                For intLoopindex = 1 To intVariableMemberCount
                                    strFileInputString = datKBfile.ReadLine()
                                    .lstStaticList.Items.Add(strFileInputString)
                                Next
                                strQuestionParts = strVariableDescription(3).Split(""""c)
                            Case " BOOLEAN"
                                .cboType.Text = "Boolean"
                                strQuestionParts = strVariableDescription(2).Split(""""c)
                            Case " Boolean"
                                .cboType.Text = "Boolean"
                                strQuestionParts = strVariableDescription(2).Split(""""c)
                            Case " NUMERIC"
                                .cboType.Text = "Numeric Range"
                                If strVariableDescription(2) = " DEFAULT" Then ' default range
                                    .optDefault.Checked = True
                                Else
                                    .optSpecify.Checked = True      ' user specified range
                                    strNumericParts = strVariableDescription(2).Split(" "c)
                                    .txtSpecify1.Text = strNumericParts(2)
                                    .txtSpecify2.Text = strNumericParts(4)
                                End If
                                strQuestionParts = strVariableDescription(3).Split(""""c)
                        End Select
                        If strQuestionParts(0) = " GOAL " Then
                            .txtQuestion.Text = vbNullString
                        Else
                            If strQuestionParts(1) = "" Then
                                .txtQuestion.Text = " "
                            Else
                                .txtQuestion.Text = strQuestionParts(1)
                            End If
                        End If
                        Select Case strQuestionParts(0)
                            Case " INITIAL "
                                .chkInitialData.Checked = True
                                '.chkAskable.Checked = False
                                '.chkGoal.Checked = False
                            Case " ASKABLE "
                                .chkAskable.Checked = True
                                '.chkInitialData.Checked = False
                                '.chkGoal.Checked = False
                            Case " NOT_ASKABLE "
                                .chkNotAskable.Checked = True
                                '.chkAskable.Checked = False
                                '.chkInitialData.Checked = False
                                '.chkGoal.Checked = False
                            Case " GOAL "
                                .chkGoal.Checked = True
                                '.chkAskable.Checked = False
                                '.chkInitialData.Checked = False
                        End Select
                        .btnOK_Click(frmAddVariable.DefInstance.btnOK, New System.EventArgs)
                    End With
                End If
                strFileInputString = datKBfile.ReadLine()
            End While


            'start looking for rules
            strFileInputString = datKBfile.ReadLine()
            Dim intRuleNumber As Integer
            Dim strPreAndPost(1) As String
            intRuleNumber = 0
            While datKBfile.Peek() > -1
                strFileInputString = datKBfile.ReadLine()
                If strFileInputString <> "" Then
                    strFileInputString = strFileInputString.Replace(" THEN ", "*")
                    strPreAndPost = strFileInputString.Split("*"c)
                    strPreAndPost(0) = strPreAndPost(0).Replace("IF ", "")
                    strPreAndPost(0) = strPreAndPost(0).Replace(" AND", ControlChars.NewLine & "AND")
                    strPreAndPost(0) = strPreAndPost(0).Replace(" OR", ControlChars.NewLine & "OR")
                    strPreAndPost(1) = strPreAndPost(1).Replace(", ", vbCrLf)
                    strPreAndPost(1) = strPreAndPost(1).Replace(") ", ")" & ControlChars.NewLine)

                    Dim NewItem As mscomctl.ListItem
                    NewItem = frmMain.DefInstance.lvwRule.ListItems.Add()

                    NewItem.SubItems(1) = strPreAndPost(0)
                    NewItem.SubItems(2) = strPreAndPost(1)
                    NewItem.Text = "Rule " & (intRuleNumber + 1).ToString
                    intRuleNumber += 1
                End If
            End While
            'stop reading file
            publishTitle = ""
            publishDescription = ""
            publishBackColor = Color.White
            publishBackColorString = ""

            datKBfile.Close()

            'lvwVariables.ListItems(0).Selected = True
            Dim Args As Axmscomctl.ListViewEvents_ItemClickEvent
            lvwVariables_ItemClick(eventSender, Args)
        End If
        'stop opening

    End Sub
    Public Sub mnuFilePrint_Popup(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuFilePrint.Popup
        mnuFilePrint_Click(eventSender, eventArgs)
    End Sub
    Private Sub PrintRules(ByVal sender As Object, ByVal ev As PrintPageEventArgs)
        Dim intCount As Short
        Dim intx As Integer
        Dim inty As Integer
        Dim intLineInc As Integer
        intCount = 1
        intLineInc = 20   '(FIXTHIS) replace with a function to measure the font height
        intx = 50
        inty = 50
        ev.Graphics.DrawString(strProjectFilename, New Font("Arial", 12, FontStyle.Regular), Brushes.Black, intx, inty)
        inty += intLineInc
        With frmMain.DefInstance.lvwRule
            For intCount = 1 To .ListItems.Count
                ev.Graphics.DrawString(" ", New Font("Arial", 12, FontStyle.Regular), Brushes.Black, intx, inty)
                inty += intLineInc
                ev.Graphics.DrawString(intCount, New Font("Arial", 12, FontStyle.Regular), Brushes.Black, intx, inty)
                inty += intLineInc
                ev.Graphics.DrawString("IF " & .ListItems.Item(intCount).SubItems(1), New Font("Arial", 12, FontStyle.Regular), Brushes.Black, intx, inty)
                inty += intLineInc
                ev.Graphics.DrawString("THEN" & vbTab & .ListItems.Item(intCount).SubItems(2), New Font("Arial", 12, FontStyle.Regular), Brushes.Black, intx, inty)
                inty += intLineInc
            Next intCount
        End With
        ev.HasMorePages = False
    End Sub
    Public Sub mnuFilePrint_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuFilePrint.Click
        ' Prints the knowledge base rules

        If lvwRule.ListItems.Count > 0 Then
            Dim intResult As Short
            Dim prDialog As New PrintDialog
            Dim prDoc As New Drawing.Printing.PrintDocument
            prDoc.DocumentName = strProjectFilename
            prDialog.Document = prDoc
            intResult = prDialog.ShowDialog()

            AddHandler prDoc.PrintPage, AddressOf Me.PrintRules
            If intResult = DialogResult.OK Then
                prDoc.Print()
            End If

            prDoc.Dispose()
            prDialog.Dispose()
        Else
            MsgBox("Expert systems without rules cannot be printed.", MsgBoxStyle.OKOnly + MsgBoxStyle.Critical, "No Rules")
        End If

    End Sub
    Public Sub mnuFileSave_Popup(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuFileSave.Popup
        mnuFileSave_Click(eventSender, eventArgs)
    End Sub
    Public Sub mnuFileSave_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuFileSave.Click
        ' Saves a knowledge base, current implementation

        Dim intCount As Short           'generic loop variable
        Dim intNum As Short
        Dim intFilenum As Short         'filehandle for the output file
        Dim intRuleCount As Short

        Dim RangeValues() As String     'used to split the values for a numeric range

        If strProjectFilename = "New Knowledge Base" Then    'Or cdlDialog.FileTitle = vbNullString   'removed by Greg
            mnuFileSaveAs_Click(mnuFileSaveAs, New System.EventArgs)
        Else
            ' save variables
            Try
                intFilenum = FreeFile()
                FileOpen(intFilenum, strProjectFilename, OpenMode.Output)
            Catch er As Exception
                MessageBox.Show(er.ToString)
            End Try


            PrintLine(intFilenum, "VARS:")
            PrintLine(intFilenum, "")

            With frmMain.DefInstance.lvwVariables
                For intCount = 1 To .ListItems.Count

                    Select Case .ListItems.Item(intCount).SubItems(1)
                        Case "Boolean"

                            Print(intFilenum, .ListItems(intCount).Text & ", BOOLEAN, ") 'print variable name

                            Select Case .ListItems.Item(intCount).SubItems(5) 'check for variable type
                                Case "I"
                                    Print(intFilenum, "INITIAL ")
                                Case "A"
                                    Print(intFilenum, "ASKABLE ")
                                Case "G"
                                    Print(intFilenum, "GOAL ")
                                Case "N"
                                    Print(intFilenum, "NOT_ASKABLE ")
                            End Select
                            Print(intFilenum, """" & .ListItems(intCount).SubItems(4) & """")

                        Case "Numeric Range"

                            Print(intFilenum, .ListItems(intCount).Text & ", NUMERIC, ") 'print variable name and type

                            If .ListItems(intCount).SubItems(2) = "N Default" Then
                                Print(intFilenum, "DEFAULT, ")
                            Else
                                RangeValues = Split(.ListItems(intCount).SubItems(2))
                                Print(intFilenum, "FROM " & RangeValues(1) & " TO " & RangeValues(3) & ", ")
                            End If

                            Select Case .ListItems.Item(intCount).SubItems(5) 'check for variable type
                                Case "I"
                                    Print(intFilenum, "INITIAL ")
                                Case "A"
                                    Print(intFilenum, "ASKABLE ")
                                Case "G"
                                    Print(intFilenum, "GOAL ")
                                Case "N"
                                    Print(intFilenum, "NOT_ASKABLE ")
                            End Select
                            Print(intFilenum, """" & .ListItems(intCount).SubItems(4) & """")

                        Case "Static List"

                            Print(intFilenum, .ListItems(intCount).Text & ", STATIC_LIST, " & .ListItems(intCount).SubItems(3) & ", ") 'print variable name and type

                            Select Case .ListItems.Item(intCount).SubItems(5) 'check for variable type
                                Case "I"
                                    Print(intFilenum, "INITIAL ")
                                Case "A"
                                    Print(intFilenum, "ASKABLE ")
                                Case "G"
                                    Print(intFilenum, "GOAL ")
                                Case "N"
                                    Print(intFilenum, "NOT_ASKABLE ")
                            End Select
                            Print(intFilenum, """" & .ListItems(intCount).SubItems(4) & """")
                            PrintLine(intFilenum, "")

                            RangeValues = Split(.ListItems(intCount).SubItems(2))

                            For intNum = 1 To RangeValues.Length
                                If (intNum Mod 2 = 1) Then
                                    If intNum < (RangeValues.Length - 3) Then
                                        PrintLine(intFilenum, RangeValues(intNum))
                                    ElseIf RangeValues(intNum) <> "" Then
                                        Print(intFilenum, RangeValues(intNum))
                                    End If
                                End If
                            Next intNum

                    End Select
                    PrintLine(intFilenum, "")
                    PrintLine(intFilenum, "")
                Next intCount
            End With

            PrintLine(intFilenum, "RULES:")
            PrintLine(intFilenum, "")

            With frmMain.DefInstance.lvwRule
                For intCount = 1 To .ListItems.Count
                    PrintLine(intFilenum, "IF " & Replace(.ListItems(intCount).SubItems(1), vbCrLf, " ") & " THEN " & Replace(.ListItems(intCount).SubItems(2), vbCrLf, ", "))
                Next intCount
            End With

        End If
        FileClose(intFilenum)

    End Sub
    Public Sub mnuFileSaveAs_Popup(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuFileSaveAs.Popup
        mnuFileSaveAs_Click(eventSender, eventArgs)
    End Sub
    Public Sub mnuFileSaveAs_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuFileSaveAs.Click
        'Saves a knowledge base under a specific strFilename

        Dim intFilenum As Short
        Dim strFilename As String
        Dim dlgResult As DialogResult

        On Error GoTo SaveAsErr
        With dlgSaveFile
            .Title = "Save Knowledge Base As..."
            .InitialDirectory = strProjectPath
            .Filter = "FreeShell Knowledge Base (*.fsl)|*.fsl|All Files (*.*)|*.*"
            .FileName = vbNullString
            dlgResult = .ShowDialog()

            If dlgResult = DialogResult.OK Then
                strFilename = .FileName
                strProjectFilename = .FileName
                intFilenum = FreeFile()
                FileOpen(intFilenum, strFilename, OpenMode.Output)
                FileClose(intFilenum)

                Me.Text = "::: FreeShell ::: " & strProjectFilename & " :::"
                saveCan = False
                mnuFileSave_Click(mnuFileSave, New System.EventArgs)
            End If

        End With

        Exit Sub

SaveAsErr:
        saveCan = True
        Exit Sub

    End Sub
    Public Sub mnuHelpAbout_Popup(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuHelpAbout.Popup
        mnuHelpAbout_Click(eventSender, eventArgs)
    End Sub
    Public Sub mnuHelpAbout_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuHelpAbout.Click
        ' Display the about form
        frmAbout.DefInstance.Show()
    End Sub
    Public Sub mnuViewRunSystem_Popup(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs)
        mnuViewRunSystem_Click(eventSender, eventArgs)
    End Sub
    Public Sub mnuViewRunSystem_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs)
        'publish function

    End Sub
    Private Sub tbrToolBar_ButtonClick(ByVal eventSender As System.Object, ByVal eventArgs As Axmscomctl.IToolbarEvents_ButtonClickEvent) Handles tbrToolBar.ButtonClick
        ' Handle Toolbar button presses

        Select Case eventArgs.button.Index
            Case 1 'New
                mnuFileNew_Click(mnuFileNew, New System.EventArgs)
            Case 2 'Open
                mnuFileOpen_Click(mnuFileOpen, New System.EventArgs)
            Case 3 'Save
                mnuFileSave_Click(mnuFileSave, New System.EventArgs)
            Case 5 'Print
                mnuFilePrint_Click(mnuFilePrint, New System.EventArgs)
            Case 7 'Publish the system
                mnuFilePublish_Click(mnuFilePublish, New System.EventArgs)
            Case 9 'Help
                mnuHelpAbout_Click(mnuHelpAbout, New System.EventArgs)
        End Select

    End Sub

    'mnuFilePublish_Click
    'This procedure handles the clicking of the 'Publish' item in the file menu and also
    'the clicking of the 'publish' button
    'Started:9-14-2005
    'Jonathan Birch & Mark Sparks
    Private Sub mnuFilePublish_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFilePublish.Click
        Dim strPublishFileName As String
        Dim PublishOptions As New frmPublish

        PublishOptions.txtTitle.Text = publishTitle
        PublishOptions.txtDescription.Text = publishDescription
        PublishOptions.dlgColorPicker.Color = publishBackColor
        PublishOptions.txtBackgroundColor.Text = publishBackColorString

        Dim PublishResult As DialogResult = PublishOptions.ShowDialog()

        publishTitle = PublishOptions.txtTitle.Text
        publishDescription = PublishOptions.txtDescription.Text
        publishBackColor = PublishOptions.dlgColorPicker.Color
        publishBackColorString = PublishOptions.txtBackgroundColor.Text

        If PublishResult = DialogResult.Cancel Then
            Exit Sub
        End If

        Dim dgrResult As DialogResult

        dlgSavePublish.InitialDirectory = Application.StartupPath
        dlgSavePublish.AddExtension = True
        dlgSavePublish.DefaultExt = ".html"
        dgrResult = dlgSavePublish.ShowDialog()
        If dgrResult <> DialogResult.Cancel Then
            strPublishFileName = dlgSavePublish.FileName
        Else
            Exit Sub
        End If

        ' Saves a knowledge base
        Dim intCount As Short
        Dim intIndex As Short
        Dim strRule As String
        Dim intFilenum As Short
        Dim blnSecondConclusion As Boolean
        Dim strInitialDatas As String
        Dim strGoals As String
        Dim intFilenumK As Short
        Dim intRuleCount As Short

        blnSecondConclusion = False
        strGoals = vbNullString
        strInitialDatas = vbNullString

        Dim intACount As Short
        Dim intICount As Short
        Dim intGCount As Short
        Dim strACount As String
        Dim strICount As String
        Dim strGCount As String


        Dim ExpertSystemFileNum As Short
        Dim i, h, j As Short
        Dim ClauseCount As Short
        Dim ClauseType As String
        Dim TempString As String
        Dim strValues() As String
        Dim strClauses() As String

        Dim CommonHTMLFileNum As Short

        Dim NegateCF As Boolean
        Dim NegateString As String


        ExpertSystemFileNum = FreeFile()
        FileOpen(ExpertSystemFileNum, strPublishFileName, OpenMode.Output)

        'output header
        PrintLine(ExpertSystemFileNum, "<HTML><HEAD><SCRIPT Language='JavaScript'><!--")
        PrintLine(ExpertSystemFileNum, "var title = '" & Replace(publishTitle, "'", "\'") & "'")
        PrintLine(ExpertSystemFileNum, "var description = '" & Replace(publishDescription, "'", "\'") & "'")
        PrintLine(ExpertSystemFileNum, "var backColor = '" & publishBackColorString & "'")

        PrintLine(ExpertSystemFileNum, "var VAR_NAME = 0")
        PrintLine(ExpertSystemFileNum, "var VAR_TYPE = 1")
        PrintLine(ExpertSystemFileNum, "var VAR_QUESTION = 2")
        PrintLine(ExpertSystemFileNum, "var VAR_QTYPE = 3")
        PrintLine(ExpertSystemFileNum, "var VAR_SPECDATA = 4")
        PrintLine(ExpertSystemFileNum, "var VAR_SPECDATA2 = 5")
        PrintLine(ExpertSystemFileNum, "var VAR_VALUE = 6")
        PrintLine(ExpertSystemFileNum, "var VAR_CF = 7")
        PrintLine(ExpertSystemFileNum, "var VAR_HASBEENSET = 8")
        PrintLine(ExpertSystemFileNum, "var VAR_CANCHANGE = 9")


        PrintLine(ExpertSystemFileNum, "var RULE_CONDITIONS = 0")
        PrintLine(ExpertSystemFileNum, "var RULE_TYPE = 1")
        PrintLine(ExpertSystemFileNum, "var RULE_CONCLUSIONS = 2")
        PrintLine(ExpertSystemFileNum, "var RULE_FIRED = 3")
        PrintLine(ExpertSystemFileNum, "var RULE_UNFIREABLE = 4")

        PrintLine(ExpertSystemFileNum, "var CONDITION_VAR = 0")
        PrintLine(ExpertSystemFileNum, "var CONDITION_OP = 1")
        PrintLine(ExpertSystemFileNum, "var CONDITION_VALUE = 2")

        PrintLine(ExpertSystemFileNum, "var CONCLUSION_VAR = 0")
        PrintLine(ExpertSystemFileNum, "var CONCLUSION_VALUE = 1")
        PrintLine(ExpertSystemFileNum, "var CONCLUSION_CF = 2")

        'output variable definitions
        With lvwVariables
            PrintLine(ExpertSystemFileNum, "var gVarArray = new Array(" & .ListItems.Count & ")")
            For i = 1 To .ListItems.Count
                TempString = "gVarArray[" & (i - 1) & "]"
                PrintLine(ExpertSystemFileNum, TempString & " = new Array(9)")
                PrintLine(ExpertSystemFileNum, TempString & "[0]= '" & Replace(.ListItems(i).Text, "'", "\'") & "'") 'first the variable name
                PrintLine(ExpertSystemFileNum, TempString & "[1]= '" & Replace(.ListItems(i).SubItems(5), "'", "\'") & "'") 'then the var type
                PrintLine(ExpertSystemFileNum, TempString & "[2]= '" & Replace(Trim(.ListItems(i).SubItems(4)), "'", "\'") & "'") 'then the question
                PrintLine(ExpertSystemFileNum, TempString & "[3]= '" & Replace(.ListItems(i).SubItems(1), "'", "\'") & "'") 'then the question type

                'store the range for numeric values or the options for static lists
                If .ListItems.Item(i).SubItems(1) = "Boolean" Then
                    PrintLine(ExpertSystemFileNum, TempString & "[4]= ''") 'no special data for booleans
                    PrintLine(ExpertSystemFileNum, TempString & "[5]= ''") 'no special data for booleans

                    PrintLine(ExpertSystemFileNum, TempString & "[6]= ''") 'this is an empty placeholder for the variable's value
                    PrintLine(ExpertSystemFileNum, TempString & "[7]= 0")   ' this is an empty placeholder for the variable's cf value
                ElseIf .ListItems.Item(i).SubItems(1) = "Numeric Range" Then
                    If .ListItems.Item(i).SubItems(2) = "N Default" Then
                        PrintLine(ExpertSystemFileNum, TempString & "[4]= 'Default'") 'default range
                        PrintLine(ExpertSystemFileNum, TempString & "[5]= ''") 'no special data for booleans
                    Else
                        PrintLine(ExpertSystemFileNum, TempString & "[4]= 'Defined Range'") 'defined range

                        strValues = Split(.ListItems.Item(i).SubItems(2), "#")
                        PrintLine(ExpertSystemFileNum, TempString & "[5] = new Array(2)") 'defined range
                        PrintLine(ExpertSystemFileNum, TempString & "[5][0] = " & Trim(Replace(strValues(0), "N ", "")))
                        PrintLine(ExpertSystemFileNum, TempString & "[5][1] = " & Trim(Replace(strValues(1), " ", "")))

                        PrintLine(ExpertSystemFileNum, TempString & "[6]= ''") 'this is an empty placeholder for the variable's value
                        PrintLine(ExpertSystemFileNum, TempString & "[7]= 0")   ' this is an empty placeholder for the variable's cf value
                    End If
                Else
                    'it's a static list
                    PrintLine(ExpertSystemFileNum, TempString & "[4] = " & .ListItems(i).SubItems(3)) 'number of options

                    'build the option array
                    PrintLine(ExpertSystemFileNum, TempString & "[5] = new Array(" & .ListItems(i).SubItems(3) & ")")

                    strValues = Split(.ListItems.Item(i).SubItems(2), " # ")
                    strValues(0) = Replace(strValues(0), "S ", "")

                    For h = 1 To .ListItems(i).SubItems(3)
                        PrintLine(ExpertSystemFileNum, TempString & "[5][" & (h - 1) & "] = '" & strValues(h - 1) & "'")
                    Next

                    'build an array to hold the individual CF values for the static list options
                    PrintLine(ExpertSystemFileNum, TempString & "[7]= new Array(" & .ListItems(i).SubItems(3) & ")") 'a new cf value placeholder for each option in a static list.
                    For w As Integer = 1 To .ListItems(i).SubItems(3)
                        PrintLine(ExpertSystemFileNum, TempString & "[7][" & (w - 1) & "] = 0")
                    Next

                End If

                PrintLine(ExpertSystemFileNum, TempString & "[8]= 0") 'this is the variable's "changed" status
                PrintLine(ExpertSystemFileNum, TempString & "[9]= true") 'this is the variable's "static" status

            Next
        End With

        With lvwRule
            PrintLine(ExpertSystemFileNum, "var gRuleArray = new Array(" & .ListItems.Count & ")")
            For i = 1 To .ListItems.Count
                'common prefix for assigning members of a single rule tuple
                'each rule has five elements: Condition list, Conclusion List, Rule Type (AND, OR , SIMPLE), Fired, Unfirable
                TempString = "gRuleArray[" & (i - 1) & "]"
                PrintLine(ExpertSystemFileNum, TempString & " = new Array(5)")

                'First, count the number of "IF" clauses
                ClauseCount = 1
                For h = 1 To .ListItems(i).SubItems(1).Length
                    If (Asc(.ListItems(i).SubItems(1).Chars(h - 1)) = 13) Then
                        ClauseCount = ClauseCount + 1
                    End If
                Next

                'Make element 0 an array with one element for each IF clause
                PrintLine(ExpertSystemFileNum, TempString & "[0] = new Array(" & ClauseCount & ")")

                ClauseType = "SIMPLE"

                'Now process the actual IF clauses
                strValues = Split(.ListItems(i).SubItems(1))
                j = 0
                For h = 1 To ClauseCount
                    'Each clause is a 5-element array (VARIABLE, OPERAND, VALUE)
                    PrintLine(ExpertSystemFileNum, TempString & "[0][" & (h - 1) & "] = new Array(3)")

                    PrintLine(ExpertSystemFileNum, TempString & "[0][" & (h - 1) & "][0] = '" & Replace(strValues(j), "'", "\'") & "'")
                    j = j + 1
                    PrintLine(ExpertSystemFileNum, TempString & "[0][" & (h - 1) & "][1] = '" & strValues(j) & "'")
                    j = j + 1

                    If (Microsoft.VisualBasic.Right(strValues(j), 3) = "AND") Then
                        strValues(j) = Microsoft.VisualBasic.Left(strValues(j), strValues(j).Length - 5)
                        ClauseType = "AND"
                    ElseIf (Microsoft.VisualBasic.Right(strValues(j), 2) = "OR") Then
                        strValues(j) = Microsoft.VisualBasic.Left(strValues(j), strValues(j).Length - 4)
                        ClauseType = "OR"
                    End If

                    PrintLine(ExpertSystemFileNum, TempString & "[0][" & (h - 1) & "][2] = '" & Replace(strValues(j), "'", "\'") & "'")
                    j = j + 1
                Next

                'Store the IF clause type
                PrintLine(ExpertSystemFileNum, TempString & "[1] = '" & ClauseType & "'")


                'Now, count the number of "THEN" clauses
                ClauseCount = 1
                For h = 1 To .ListItems(i).SubItems(2).Length
                    If (Asc(.ListItems(i).SubItems(2).Chars(h - 1)) = 13) Then
                        ClauseCount = ClauseCount + 1
                    End If
                Next

                'Make element 2 an array with one element for each THEN clause
                PrintLine(ExpertSystemFileNum, TempString & "[2] = new Array(" & ClauseCount & ")")

                'Now process the actual THEN clauses
                Dim strTemp As String
                strTemp = Replace(.ListItems(i).SubItems(2), vbCrLf, " ")
                strValues = Split(strTemp)
                j = 0
                For h = 1 To ClauseCount
                    'Each clause is a 3-element array (VARIABLE, VALUE, CF)
                    PrintLine(ExpertSystemFileNum, TempString & "[2][" & (h - 1) & "] = new Array(3)")

                    'strip any leading CRLF
                    If (h > 1) Then
                        strValues(j) = Microsoft.VisualBasic.Right(strValues(j), strValues(j).Length - 2)
                    End If

                    'Variable
                    PrintLine(ExpertSystemFileNum, TempString & "[2][" & (h - 1) & "][0] = '" & Replace(strValues(j), "'", "\'") & "'")
                    j = j + 1 'skip the "=" element

                    NegateCF = (strValues(j) = "!=")

                    j = j + 1

                    'Value
                    PrintLine(ExpertSystemFileNum, TempString & "[2][" & (h - 1) & "][1] = '" & Replace(strValues(j), "'", "\'") & "'")
                    j = j + 1

                    'strip the trailing ")"
                    strValues(j) = Microsoft.VisualBasic.Left(strValues(j), strValues(j).Length - 1)

                    'strip the "CF("
                    strValues(j) = Microsoft.VisualBasic.Right(strValues(j), strValues(j).Length - 3)

                    NegateString = strValues(j)
                    If (NegateCF) Then
                        If (strValues(j).Chars(1) = "-") Then
                            NegateString = Microsoft.VisualBasic.Right(NegateString, NegateString.Length - 1)
                        Else
                            NegateString = "-" & NegateString
                        End If
                    End If

                    'output the CF
                    PrintLine(ExpertSystemFileNum, TempString & "[2][" & (h - 1) & "][2] = '" & NegateString & "'")
                    j = j + 1
                Next
                PrintLine(ExpertSystemFileNum, TempString & "[3] = 0") 'FIRED
                PrintLine(ExpertSystemFileNum, TempString & "[4] = 0") 'UNFIRABLE

            Next
        End With

        'PrintLine(ExpertSystemFileNum, "--></SCRIPT>")

        CommonHTMLFileNum = FreeFile()

        If (Application.StartupPath.EndsWith("\")) Then
            FileOpen(CommonHTMLFileNum, Application.StartupPath + "CommonElements.html", OpenMode.Input)
        Else
            FileOpen(CommonHTMLFileNum, Application.StartupPath + "\CommonElements.html", OpenMode.Input)
        End If

        While Not (EOF(CommonHTMLFileNum))
            TempString = LineInput(CommonHTMLFileNum)
            PrintLine(ExpertSystemFileNum, TempString)
        End While

        System.Diagnostics.Process.Start(dlgSavePublish.FileName)
        Try
            FileClose(CommonHTMLFileNum)
            FileClose(ExpertSystemFileNum)
        Catch er As Exception
        End Try

    End Sub

    Private Sub btnAddVariable_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles btnAddVariable.Click
        ' Display "Add Variable" form

        frmAddVariable.DefInstance.Text = "Add Variable"
        frmAddVariable.DefInstance.chkInitialData.Checked = True
        frmAddVariable.DefInstance.ShowDialog()
        saveCan = True
    End Sub
    Private Sub btnEditVariable_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles btnEditVariable.Click
        ' Edit selected variable using the Add Variable form

        Dim intIndex As Short
        Dim strValues() As String
        Dim intCounter As Short

        ' initialize components on frmAddVariable form

        frmAddVariable.DefInstance.lstStaticList.Items.Clear()
        frmAddVariable.DefInstance.txtSpecify1.Text = vbNullString
        frmAddVariable.DefInstance.txtSpecify2.Text = vbNullString

        With lvwVariables
            If .ListItems.Count > 0 Then
                intIndex = .SelectedItem.Index
                If intIndex > -1 Then

                    ' fill in variable name

                    frmAddVariable.DefInstance.txtName.Text = .ListItems.Item(intIndex).Text

                    If .ListItems.Item(intIndex).SubItems(1) = "Boolean" Then
                        frmAddVariable.DefInstance.cboType.SelectedIndex = 0
                    ElseIf .ListItems.Item(intIndex).SubItems(1) = "Numeric Range" Then
                        ' fill in numeric range specific details

                        frmAddVariable.DefInstance.cboType.SelectedIndex = 1

                        If .ListItems.Item(intIndex).SubItems(2) = "N Default" Then
                            frmAddVariable.DefInstance.optDefault.Checked = True
                        Else
                            frmAddVariable.DefInstance.optSpecify.Checked = True
                            strValues = Split(.ListItems.Item(intIndex).SubItems(2), "#")

                            frmAddVariable.DefInstance.txtSpecify1.Text = Trim(Replace(strValues(0), "N ", ""))
                            frmAddVariable.DefInstance.txtSpecify2.Text = Trim(Replace(strValues(1), " ", ""))
                        End If
                    Else ' Static List
                        ' fill in static list specific details

                        frmAddVariable.DefInstance.cboType.SelectedIndex = 2
                        strValues = Split(.ListItems.Item(intIndex).SubItems(2), " # ")
                        strValues(0) = Replace(strValues(0), "S ", "")
                        intCounter = 1
                        For intCounter = 1 To CInt(.ListItems.Item(intIndex).SubItems(3))
                            frmAddVariable.DefInstance.lstStaticList.Items.Add((strValues(intCounter - 1)))
                        Next intCounter
                    End If

                    ' fill in question

                    frmAddVariable.DefInstance.txtQuestion.Text = .ListItems.Item(intIndex).SubItems(4)

                    If .ListItems.Item(intIndex).SubItems(5) = "I" Then
                        frmAddVariable.DefInstance.chkInitialData.Checked = True
                        'frmAddVariable.DefInstance.chkGoal.Enabled = False
                        'frmAddVariable.DefInstance.chkAskable.Checked = True
                        'frmAddVariable.DefInstance.chkAskable.Enabled = False
                    ElseIf .ListItems.Item(intIndex).SubItems(5) = "G" Then
                        'frmAddVariable.DefInstance.chkInitialData.Enabled = False
                        'frmAddVariable.DefInstance.chkAskable.Enabled = False
                        frmAddVariable.DefInstance.chkGoal.Checked = True
                    ElseIf .ListItems.Item(intIndex).SubItems(5) = "A" Then
                        'frmAddVariable.DefInstance.chkGoal.Enabled = False
                        frmAddVariable.DefInstance.chkAskable.Checked = True
                    Else
                        frmAddVariable.DefInstance.chkNotAskable.Checked = True
                    End If

                    frmAddVariable.DefInstance.txtName.Enabled = False ' do not allow editing of name
                    frmAddVariable.DefInstance.cboType.Enabled = False ' do not allow editing of type
                    frmAddVariable.DefInstance.Text = "Edit Variable"
                    frmAddVariable.DefInstance.ShowDialog()
                    frmAddVariable.DefInstance.Text = "Add Variable"

                    If Not (.SelectedItem Is Nothing) Then .SelectedItem.Selected = False
                    btnEditVariable.Enabled = False
                    btnRemoveVariable.Enabled = False

                End If
            End If

        End With
        saveCan = True
    End Sub
    Private Sub btnRemoveVariable_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles btnRemoveVariable.Click
        'Remove a variable from the list

        Dim intIndex As Short

        With lvwVariables

            If .ListItems.Count > 0 Then

                intIndex = .SelectedItem.Index
                If intIndex > -1 Then
                    .ListItems.Remove((intIndex))
                    frmRuleCreator.DefInstance.cbIfVariable.Items.RemoveAt(intIndex - 1)
                    frmRuleCreator.DefInstance.cbThenVariable.Items.RemoveAt(intIndex - 1)
                    saveCan = True
                    .Focus()
                End If
            End If

            If Not (.SelectedItem Is Nothing) Then .SelectedItem.Selected = False
            btnEditVariable.Enabled = False
            btnRemoveVariable.Enabled = False

        End With
    End Sub

    'Udpated this function to reorder the lists in the rule creator window
    '11-15-2005
    'Jonathan Birch
    Private Sub lvwVariables_ColumnClick(ByVal eventSender As System.Object, ByVal eventArgs As Axmscomctl.ListViewEvents_ColumnClickEvent) Handles lvwVariables.ColumnClick
        ' Sort Ascending or Descending

        lvwVariables.Sorted = True
        lvwVariables.SortKey = eventArgs.columnHeader.Index - 1

        If lvwVariables.SortOrder = mscomctl.ListSortOrderConstants.lvwAscending Then
            lvwVariables.SortOrder = mscomctl.ListSortOrderConstants.lvwDescending
        Else
            lvwVariables.SortOrder = mscomctl.ListSortOrderConstants.lvwAscending
        End If

        frmRuleCreator.DefInstance.cbIfVariable.Items.Clear()
        frmRuleCreator.DefInstance.cbThenVariable.Items.Clear()
        Dim i
        For i = 1 To lvwVariables.ListItems.Count
            frmRuleCreator.DefInstance.cbIfVariable.Items.Add(Trim(lvwVariables.ListItems(i).Text))
            frmRuleCreator.DefInstance.cbThenVariable.Items.Add(Trim(lvwVariables.ListItems(i).Text))
        Next

    End Sub

    Private Sub lvwVariables_ItemClick(ByVal eventSender As System.Object, ByVal eventArgs As Axmscomctl.ListViewEvents_ItemClickEvent) Handles lvwVariables.ItemClick
        ' Show details for selected variable

        Dim strKeyString As String
        Dim intKeyLength As Integer
        Dim strFinalString As String
        Dim intIndex As Short
        Dim intCount As Short

        lstStaticList.Items.Clear()
        lstStaticList.Visible = False
        lblInfo.Visible = False

        btnEditVariable.Enabled = True
        btnRemoveVariable.Enabled = True

        Select Case eventArgs.item.SubItems(1)
            Case "Boolean"
                lblInfo.Text = "Boolean values are either TRUE or FALSE."
                lblInfo.Visible = True
            Case "Numeric Range"
                If eventArgs.item.SubItems(2) = "N Default" Then
                    lblInfo.Text = "Numeric range values are set to default."
                Else
                    lblInfo.Text = "Numeric range values are set to the range "
                    intKeyLength = Len(eventArgs.item.SubItems(2)) - 2
                    strKeyString = VB.Right(eventArgs.item.SubItems(2), intKeyLength)
                    For intIndex = 1 To intKeyLength
                        If AscW(Mid(strKeyString, intIndex)) <> 35 Then '35 = "#" separator character
                            strFinalString = VB.Left(strKeyString, intIndex)
                        Else
                            lblInfo.Text = lblInfo.Text & Trim(strFinalString) & " to "
                            lblInfo.Text = lblInfo.Text & Trim(VB.Right(strKeyString, intKeyLength - intIndex)) & "."
                            intIndex = intKeyLength
                        End If
                    Next intIndex
                End If
                lblInfo.Visible = True
            Case "Static List"
                lstStaticList.Visible = True
                intKeyLength = Len(eventArgs.item.SubItems(2)) - 2
                strKeyString = VB.Right(eventArgs.item.SubItems(2), intKeyLength)
                intIndex = 1
                Do While intIndex < intKeyLength
                    If AscW(Mid(strKeyString, intIndex)) <> 35 Then '35 = "#" separator character
                        strFinalString = VB.Left(strKeyString, intIndex)
                    Else
                        lstStaticList.Items.Add((Trim(strFinalString)))
                        strKeyString = Mid(strKeyString, intIndex + 2)
                        intIndex = 0
                        intKeyLength = Len(strKeyString)
                    End If
                    intIndex = intIndex + 1
                Loop
        End Select
    End Sub
    Private Sub btnAdd_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles btnAdd.Click
        ' Show frmRule creator if variables exist, else
        ' Display message box

        If frmMain.DefInstance.lvwVariables.ListItems.Count <> 0 Then
            frmRuleCreator.DefInstance.blnThisIsAnEditedRule = False
            frmRuleCreator.DefInstance.btnAddRule.Text = "&Add Rule"
            frmRuleCreator.DefInstance.ShowDialog()
            saveCan = True
        Else
            MsgBox("No variables have been created.  Please create variables before creating the rules.", MsgBoxStyle.OKOnly + MsgBoxStyle.Critical, "No Variables")
        End If

    End Sub
    Private Sub btnRemove_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles btnRemove.Click
        ' Remove selected rule

        Dim intIndex As Short

        With lvwRule
            If .ListItems.Count > 0 Then
                intIndex = .SelectedItem.Index
                If intIndex > -1 Then
                    .ListItems.Remove((intIndex))
                    .Focus()
                    NumberRules() ' re-number rules since one has been removed
                    saveCan = True  ' A rule has been removed so we can save.
                End If
            End If
            .Focus()

            If Not (.SelectedItem Is Nothing) Then .SelectedItem.Selected = False
            btnRemove.Enabled = False

        End With

        txtIf.Text = vbNullString
        txtThen.Text = vbNullString

    End Sub
    Private Sub lvwRule_ItemClick(ByVal eventSender As System.Object, ByVal eventArgs As Axmscomctl.ListViewEvents_ItemClickEvent) Handles lvwRule.ItemClick
        ' Rule has been clicked on; display its IF and THEN parts in the textboxes

        txtIf.Text = eventArgs.item.SubItems(1)
        txtThen.Text = eventArgs.item.SubItems(2)

        btnRemove.Enabled = True

    End Sub
    Private Sub pnlConditions_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pnlConditions.Resize
        txtIf.Width = 233 + pnlConditions.Width - 248
        txtIf.Height = 144 + (pnlConditions.Height - 379) / 2

        txtThen.Width = 233 + pnlConditions.Width - 248
        txtThen.Height = 167 + (pnlConditions.Height - 379) / 2

        lblThen.Top = txtIf.Height + txtIf.Top + 16
        txtThen.Top = lblThen.Top + 20

    End Sub
    Private Sub btnEditRule_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditRule.Click

        If lvwRule.ListItems.Count <> 0 Then
            If lvwRule.SelectedItem.Index <> -1 Then
                'frmRuleCreator.DefInstance.txtIf.Text = lvwRule.SelectedItem.SubItems(1)
                'frmRuleCreator.DefInstance.txtThen.Text = lvwRule.SelectedItem.SubItems(2)

                frmRuleCreator.DefInstance.lbIfClauses.Items.Clear()
                Dim IfClauses() As String
                Dim ThenClauses() As String
                Dim I As Integer

                IfClauses = Split(lvwRule.SelectedItem.SubItems(1), vbCrLf)
                For I = 0 To (IfClauses.Length - 1)
                    frmRuleCreator.DefInstance.lbIfClauses.Items.Add(IfClauses(I))
                Next

                If (IfClauses.Length > 1) Then
                    If (Microsoft.VisualBasic.Left(IfClauses(1), 3) = "AND") Then
                        frmRuleCreator.DefInstance.radAnd.Checked = True
                    Else
                        frmRuleCreator.DefInstance.radOr.Checked = True
                    End If
                End If

                frmRuleCreator.DefInstance.lbThenClauses.Items.Clear()
                ThenClauses = Split(lvwRule.SelectedItem.SubItems(2), vbCrLf)
                For I = 0 To (ThenClauses.Length - 1)
                    frmRuleCreator.DefInstance.lbThenClauses.Items.Add(ThenClauses(I))
                Next

                frmRuleCreator.DefInstance.blnThisIsAnEditedRule = True
                frmRuleCreator.DefInstance.btnAddRule.Text = "&Update Rule"
                frmRuleCreator.DefInstance.ShowDialog()
            End If
        End If
        saveCan = True
    End Sub
    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        mnuFileNew.PerformClick()
    End Sub

End Class